function [selected_vectors]=filter_weights(weights,K)

    [m,n]=size(weights);
    R=range(weights);
    p=(1./R)./sum(1./R);
    initial_d=0;
    d=sqrt(sum((p.*R).^2))/4;
    Dd=d/2;
    issmall=0;islarge=0;
    reduced_set_size=0;
    iter=1;
    while reduced_set_size~=K
        selected_vectors=1;cont=1;
        while cont==1
            for k=1:length(selected_vectors)
                diff=(repmat(p,m,1).*abs(repmat(weights(selected_vectors(k),:),m,1)-weights)).^2;
                fil_dist(:,k)=sqrt(sum(diff,2));
                clear diff
            end
            y=fil_dist;
            y(fil_dist<d)=1;
            y(fil_dist>=d)=0;
            y(selected_vectors,:)=1;
            f=find(sum(y,2)==0);
            if length(f)>0
                selected_vectors=[selected_vectors;f(1)];
                cont=1;
            else
                cont=0;
            end
            clear f fil_dist y
        end
        reduced_set_size=length(selected_vectors);
        if reduced_set_size<K
            issmall=1;
        elseif reduced_set_size>K
            islarge=1;
        end;
        if issmall==1 & islarge==1
            Dd=Dd/2;
        else
            if iter>1
                Dd=2*Dd;
            end
        end
        if reduced_set_size<K
            if d-Dd<0
                Dd=unifrnd(0,d);
            end
            d=d-Dd;
        elseif reduced_set_size>K
            d=d+Dd;
        end;
        iter=iter+1;
        if iter>50
            if reduced_set_size<K
                f=find(ismember([1:m]',selected_vectors)==0);
                selected_vectors=[selected_vectors;f(1:K-reduced_set_size)];
            else
                sl=selected_vectors;
                clear selected_vectors
                selected_vectors=sl(1:K);
            end
            reduced_set_size=length(selected_vectors);
        end
    end;
            
    